%% system parameters
clear all;
N=64;
tend=1;Delta=1/N;
reasol=exactsol(tend,N);
disp('grid number is');
disp(N);

%% ocIIF+Pade
Axy=XYgetMatrix(N,0.1,-0.15,0.1,2*pi/N,2*pi/N)*Delta;
Axz=XYgetMatrix(N,0.1,0.2,0.2,2*pi/N,2*pi/N)*Delta;
Ayz=XYgetMatrix(N,0.2,0.15,0.1,2*pi/N,2*pi/N)*Delta;
base1=1:N^2;base2=zeros(1,N^2);base3=zeros(1,N^2);
for i=1:N
    base2((1:N)+(i-1)*N)=(1:N)+(i-1)*N^2;
    base3((1:N)+(i-1)*N)=(1:N:(N*N-N+1))+(i-1)*N^2;
end;
sols=exactsol(0,N);

tic;
Exy=expm(Axy);Exz=expm(Axz);Eyz=expm(Ayz);
for j=1:N
    sol=(1+0.4*Delta)*sols;
    for i=1:N
        sol(base1+(i-1)*N^2)=Eyz*sol(base1+(i-1)*N^2);
    end;
    for i=1:N
        sol(base2+(i-1)*N)=Exz*sol(base2+(i-1)*N);
    end;
    for i=1:N
        sol(base3+(i-1))=Exy*sol(base3+(i-1));
    end;
    sols=sol/(1-0.4*Delta);
end;
disp('the total time for ocIIF+Pade');
toc;
disp('the error for ocIIF+Pade');
disp(max(abs(reasol-sols)));

%% IIF+Pade
% Awhole=wholeMatrix(N)*Delta;
% sols=exactsol(0,N);
% tic;
% Eawhole=expm(Awhole);
% for i=1:N
%     sols=Eawhole*(1+0.4*Delta)*sols/(1-0.4*Delta);
% end;
% disp('the total time for IIF+Pade');
% toc;
% disp('the error for IIF+Pade');
% disp(max(abs(reasol-sols)));
