%% Order of Accuracy Test for ocIIF2

%% Step 1: parameters are given
N=8;sol=exactsol(0,N);h=2*pi/N;dt=1/(N);tend=1;
disp('N=');disp(N);
base1=1:N^2;base2=zeros(1,N^2);base3=zeros(1,N^2);
for i=1:N
    base2((1:N)+(i-1)*N)=(1:N)+(i-1)*N^2;
    base3((1:N)+(i-1)*N)=(1:N:(N*N-N+1))+(i-1)*N^2;
end;
Axy=XYNonMatrix(N);Ayz=YZNonMatrix(N);Awhole=WholeMatrix(N);
% give additional term
addmore=zeros(N^3,1);
for i=1:N
    for j=1:N
        for k=1:N
            x=(i-1)*h;y=(j-1)*h;z=(k-1)*h;
            addmore((i-1)*N^2+(j-1)*N+k)=(59+10*cos(x)-10*cos(y)-15*sin(x+y))/30;
        end;
    end;
end;

% exa=zeros(N^2,1);
% for i=1:N
%     for j=1:N
%         x=(i-1)*h;y=(j-1)*h;z=pi;
%         exa((i-1)*N+j)=exp(-0.1)*sin(x+y+z);
%     end;
% end;
% XX=linspace(0,2*pi,N+1);XX=XX(1:N);
% [X Y]=meshgrid(XX);
% subplot(1,2,1),surf(X,Y,reshape(exa,N,N),'EdgeColor','none'),axis([0 2*pi-h 0 2*pi-h -1 1])
% shading interp;

%% Step 2: With Splitting Method
tic;
sol1=sol;
for k=1:(round(N))
    sol1=sol1+sol1.*addmore*dt/2;
    % xy plane-dt/2
    for i=1:N
        sol1(base3+(i-1))=expv(dt/2,Axy,sol1(base3+(i-1)));
    end;
    % yz plane-dt/2
    for i=1:N
        x=(i-1)*h;
        sol1(base1+(i-1)*N^2)=expv(dt/2*(1+cos(x)),Ayz,sol1(base1+(i-1)*N^2));
    end;
    % xz plane-dt
    for i=1:N
        y=(i-1)*h;Axz=XZNonMatrix(N,y);
        sol1(base2+(i-1)*N)=expv(dt,Axz,sol1(base2+(i-1)*N));
    end;
    % yz plane-dt/2
    for i=1:N
        x=(i-1)*h;
        sol1(base1+(i-1)*N^2)=expv(dt/2*(1+cos(x)),Ayz,sol1(base1+(i-1)*N^2));
    end;
    % xy plane-dt/2
    for i=1:N
        sol1(base3+(i-1))=expv(dt/2,Axy,sol1(base3+(i-1)));
    end;
    sol1=sol1./(1-dt/2*addmore);
end;
disp('the error for splitting');disp(max(abs(sol1-exactsol(tend,N))));
disp('the time for splitting');toc;

%% Step 3: IIF
tic;
sol2=sol;
for k=1:(round(N))
    sol2=sol2+sol2.*addmore*dt/2;
    sol2=expv(dt,Awhole,sol2);
    sol2=sol2./(1-dt/2*addmore);
end;
disp('the error for IIF');disp(max(abs(sol2-exactsol(tend,N))));
disp('the time for IIF');toc;

