%% Test the efficiency of the ocIIF method --> IIF method
N=64;h=2*pi/N;dt=1/(N);tend=1;
disp('N=');disp(N);
base1=1:N^2;base2=zeros(1,N^2);base3=zeros(1,N^2);
for i=1:N
    base2((1:N)+(i-1)*N)=(1:N)+(i-1)*N^2;
    base3((1:N)+(i-1)*N)=(1:N:(N*N-N+1))+(i-1)*N^2;
end;
Axy=XYNonMatrix(N);Ayz=YZNonMatrix(N);Awhole=wholeMatrix(N);
% give additional term
addmore=zeros(N^3,1);
for i=1:N
    for j=1:N
        for k=1:N
            x=(i-1)*h;y=(j-1)*h;z=(k-1)*h;
            addmore((i-1)*N^2+(j-1)*N+k)=(59+10*cos(x)-10*cos(y)-15*sin(x+y))/30;
        end;
    end;
end;



%% Step 2: ocIIF method+Pade+Strang
tic;
% EAxy=zeros(N^2,N^2,N);EAyz=zeros(N^2,N^2,N);EAxz=zeros(N^2,N^2,N);
% for i=1:N
%     EAxy(:,:,i)=expm(Axy*dt/2);
%     EAyz(:,:,i)=expm(Ayz*(1+cos((i-1)*h))*dt/2);
%     EAxz(:,:,i)=expm(XZNonMatrix(N,(i-1)*h)*dt/2);
% end;

EAxy=cell(1,N);EAyz=cell(1,N);EAxz=cell(1,N);
for i=1:N
    EAxy(i)={expm(Axy*dt/2)};
    EAyz(i)={expm(Ayz*(1+cos((i-1)*h))*dt/2)};
    EAxz(i)={expm(XZNonMatrix(N,(i-1)*h)*dt)};
end;


sol1=exactsol(0,N);
for k=1:(round(tend/dt))
    sol1=sol1+sol1.*addmore*dt/2;
     
    
    % xy plane-dt/2
    for i=1:N
        sol1(base3+(i-1))=EAxy{i}*sol1(base3+(i-1));
    end;
    % yz plane-dt/2
    for i=1:N
        sol1(base1+(i-1)*N^2)=EAyz{i}*sol1(base1+(i-1)*N^2);
    end;
    % xz plane-dt
    for i=1:N
        sol1(base2+(i-1)*N)=EAxz{i}*sol1(base2+(i-1)*N);
    end;
    % yz plane-dt/2
    for i=1:N
        sol1(base1+(i-1)*N^2)=EAyz{i}*sol1(base1+(i-1)*N^2);
    end;
    % xy plane-dt/2
    for i=1:N
        sol1(base3+(i-1))=EAxy{i}*sol1(base3+(i-1));
    end;



    sol1=sol1./(1-dt/2*addmore);
end;
disp('the error for ocIIF+Pade');disp(max(abs((sol1-exactsol(tend,N)))));
disp('the time for ocIIF+Pade');toc;

%% Step 3: IIF+Pade
% tic;
% EAwhole=expm(Awhole*dt);
% sol2=exactsol(0,N);
% for k=1:(round(tend/dt))
%     sol2=sol2+sol2.*addmore*dt/2;
%     sol2=EAwhole*sol2;
%     sol2=sol2./(1-dt/2*addmore);
% end;
% disp('the error for IIF+Pade');disp(max(abs(sol2-exactsol(tend,N))));
% disp('the time for IIF+Pade');toc;
