clear;
close(gcf);
load result1;

yloc=0.25;
xv1=0.1;
xv2=0.4;
xv3=0.7;
scl=0.3;

win1=[xv1 yloc scl scl];
win2=[xv2 yloc scl scl];
win3=[xv3 yloc scl scl];


%% plot initial data
pini=zeros(M*M*N,1);
for i=1:M
    for j=1:M
        for k=1:N
            x=(i-1)*hx;y=(j-1)*hx;z=(k-1)*hex;
            pini((i-1)*M*N+(j-1)*N+k)=1/100*exp(-((x-30)^2+(y-40)^2+(z-20)^2)/30);
        end;
    end;
end;
pini=pini/sum(pini);
pxy1=zeros(M,M);
for i=1:M
    
    for j=1:M
        for k=1:N
            pxy1(i,j)=pxy1(i,j)+pini((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
XX=linspace(0,NXmax,M);
h=surf(XX,XX,pxy1,'EdgeColor','none'),xlabel('[{\itB}]','FontSize',15),ylabel('[{\itA}]','FontSize',15),
zlabel('probability density','FontSize',14),title('(a)','FontSize',15),;
set(h,'Position',win1);

subplot(1,3,1),surf(XX,XX,pxy1,'EdgeColor','none'),xlabel('[{\itB}]','FontSize',15),ylabel('[{\itA}]','FontSize',15),
zlabel('probability density','FontSize',14),title('(a)','FontSize',15),
shading interp;
axis([0 100 0 100]);
axis equal;
view(2);
axis([0 100 0 100]);
colorbar;



%% plot final data
pxy2=zeros(M,M);
for i=1:M
    
    for j=1:M
        for k=1:N
            pxy2(i,j)=pxy2(i,j)+pexa((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;

subplot(1,3,2),surf(XX,XX,pxy2.*(pxy2>0),'EdgeColor','none'),xlabel('[{\itB}]','FontSize',15),ylabel('[{\itA}]','FontSize',15),
zlabel('probability density','FontSize',14),title('(b)','FontSize',15),
shading interp;
axis([0 100 0 100]);
axis equal;
view(2);
axis([0 100 0 100]);
colorbar;


%% plot contour plot
subplot(1,3,3),contour(XX,XX,pxy1,6),hold on;
contour(XX,XX,pxy2,6);
[t solx]=ode45(@reactode,[0 50],[30 40 20]);
plot(solx(:,2),solx(:,1),'r -.'),xlabel('[{\itB}]','FontSize',15),ylabel('[{\itA}]','FontSize',15),title('(c)','FontSize',15),
axis([0 100 0 100]);
axis equal;
axis([0 100 0 100]);
hold off;
colorbar;

print('-depsc','-r300','drawjeremy.eps');
close(gcf);
