tic;
clc;clear all;
Nx=100;Nex=60;
dt1=2;tend1=5*dt1;
dt2=2;tend2=5*dt2;
NXmax=100;NEXmax=60;
M=Nx+1;N=Nex+1;hx=NXmax/Nx;hex=NEXmax/Nex;
p=zeros(M*M*N,1);

for i=1:M
    for j=1:M
        for k=1:N
            x=(i-1)*hx;y=(j-1)*hx;z=(k-1)*hex;
            p((i-1)*M*N+(j-1)*N+k)=1/100*exp(-((x-30)^2+(y-40)^2+(z-25)^2)/30);
        end;
    end;
end;

%RK 2nd
p1=p;
for k=1:(round(tend1/dt1))
    p1=RK_Result(p1,dt1,dt1,Nx,Nex);
    disp('RK step');disp(k);
    disp(abs(sum(p)-sum(p1)));
    disp(max(p1));
    disp(min(p1));
end;
pxy=zeros(M,M);
for i=1:M
    for j=1:M
        for k=1:N
            pxy(i,j)=pxy(i,j)+p1((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(1,2,1),surf(pxy,'EdgeColor','none');
shading interp;
axis([0 M 0 M]);

%IIF 2nd
p2=p;
for k=1:(round(tend2/dt2))
    p2=IIF_Result(p,dt2,dt2,Nx,Nex);
    disp('IIF step');disp(k);
    disp(abs(sum(p)-sum(p2)));
    disp(max(p2));
    disp(min(p2));
end;
pxy=zeros(M,M);
for i=1:M
    for j=1:M
        for k=1:N
            pxy(i,j)=pxy(i,j)+p2((i-1)*M*N+(j-1)*N+k);
        end;
    end;
end;
subplot(1,2,2),surf(pxy,'EdgeColor','none');
shading interp;
axis([0 M 0 M]);

    
