%% ocIIF Solver
NAmax=80;NEAmax=30;NA=30;NEA=15;
M1=NA+1;M2=NEA+1;h1=NAmax/NA;h2=NEAmax/NEA;

p=zeros(M1*M1*M2*M2,1);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M2
                numa=(i1-1)*h1;numb=(i2-1)*h1;ea=(i3-1)*h2;eb=(i4-1)*h2;
                p((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4)=exp(-((numa-30)^2+(numb-40)^2+(ea-15)^2+(eb-12)^2)/30);
            end;
        end;
    end;
end;
p=p/sum(p);
Adir=linspace(0,NAmax,NA+1);Bdir=Adir;
EAdir=linspace(0,NEAmax,NEA+1);EBdir=linspace(0,NEAmax,NEA+1);

baseAB=1:M2^2:(M1^2*M2^2);
baseEA=1:M2:M2^2;
baseEB=1:1:M2;

%% plot initial data
fig1=figure;
pab=zeros(M1,M1);pe=zeros(M2,M2);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M2
                pab(i1,i2)=pab(i1,i2)+p((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
                pe(i3,i4)=pe(i3,i4)+p((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4);
            end;
        end;
    end;
end;
subplot(1,2,1),surf(Adir,Bdir,pab,'EdgeColor','none');
shading interp;
subplot(1,2,2),surf(EAdir,EBdir,pe,'EdgeColor','none');
shading interp;


disp({'step',0,'total prob',sum(p),'minium prob',min(p)});
dt=2;
for kkk=1:20
    % EB, dt/2
    for i1=1:M1
        for i2=1:M1
            for i3=1:M2
                if max(abs(p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2)))>1e-10
                p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2)=expv(dt/2,getEY(NEAmax,NEA,(i2-1)*h1),p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2));
                end;
            end;
        end;
    end;
    
    % EA, dt/2
    for i1=1:M1
        for i2=1:M1
            for i4=1:M2
                if max(abs(p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1)))>1e-10
                p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1)=expv(dt/2,getEX(NEAmax,NEA,(i1-1)*h1),p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1));
                end;    
            end;
        end;
    end;
    
    % A and B, dt
    for i3=1:M2
        for i4=1:M2
            if max(abs(p(baseAB+(i3-1)*M2+i4-1)))>1e-10
            p(baseAB+(i3-1)*M2+i4-1)=expv(dt,getXYnew(NAmax,NA,(i3-1)*h2,(i4-1)*h2),p(baseAB+(i3-1)*M2+i4-1));
            end;
        end;
    end;
     % EA, dt/2
    for i1=1:M1
        for i2=1:M1
            for i4=1:M2
                if max(abs(p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1)))>1e-10
                p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1)=expv(dt/2,getEX(NEAmax,NEA,(i1-1)*h1),p(baseEA+(i1-1)*M1*M2^2+(i2-1)*M2^2+i4-1));
                end;  
            end;
        end;
    end;
    % EB, dt/2
    for i1=1:M1
        for i2=1:M1
            for i3=1:M2
                if max(abs(p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2)))>1e-10
                p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2)=expv(dt/2,getEY(NEAmax,NEA,(i2-1)*h1),p(baseEB+(i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2));
                end;
            end;
        end;
    end;
    disp({'step',kkk,'total prob',sum(p),'minium prob',min(p)});
    
end;

%% plot again
pini=zeros(M1*M1*M2*M2,1);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M2
                numa=(i1-1)*h1;numb=(i2-1)*h1;ea=(i3-1)*h2;eb=(i4-1)*h2;
                pini((i1-1)*M1*M2^2+(i2-1)*M2^2+(i3-1)*M2+i4)=exp(-((numa-30)^2+(numb-40)^2+(ea-15)^2+(eb-12)^2)/30);
            end;
        end;
    end;
end;
pini=pini/sum(pini);
fig=plotgivendata(NAmax,NA,NEAmax,NEA,pini,p);








    