%% ocIIF Solver
NAmax=80;NEAmax=8;NA=30;NEA=8;NEB=32;
M1=NA+1;M2=NEA+1;M3=NEB+1;h1=NAmax/NA;h2=NEAmax/NEA;h4=NEAmax/NEB;

p=zeros(M1*M1*M2*M3,1);
for i1=1:M1
    for i2=1:M1
        for i3=1:M2
            for i4=1:M3
                numa=(i1-1)*h1;numb=(i2-1)*h1;ea=(i3-1)*h2;eb=(i4-1)*h2;
                p((i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3+i4)=exp(-((numa-30)^2+(numb-40)^2+(ea-15)^2+(eb-12)^2)/30);
            end;
        end;
    end;
end;
p=p/sum(p);

baseAB=1:(M2*M3):(M1^2*M2*M3);
baseEA=1:M3:(M2*M3);
baseEB=1:1:M3;
tic;
dt=0.1;
for kkk=1:1
    % EB, dt/2
    for i1=1:M1
       for i2=1:M1
            for i3=1:M2
                if max(abs(p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3)))>1e-10
                p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3)=expv(dt/2,getEY(NEAmax,NEB,(i2-1)*h1),p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3));
                end;
            end;
        end;
    end;
    % EA, dt/2
    for i1=1:M1
        for i2=1:M1
            for i4=1:M3
                if max(abs(p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1)))>1e-10
                p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1)=expv(dt/2,getEX(NEAmax,NEA,(i1-1)*h1),p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1));
                end;    
            end;
        end;
    end;
    % A and B, dt
    for i3=1:M2
        for i4=1:M3
            if max(abs(p(baseAB+(i3-1)*M3+i4-1)))>1e-10
            p(baseAB+(i3-1)*M3+i4-1)=expv(dt,getXYnew(NAmax,NA,(i3-1)*h2,(i4-1)*h4),p(baseAB+(i3-1)*M3+i4-1));
            end;
        end;
    end;
    % EA, dt/2
    for i1=1:M1
        for i2=1:M1
            for i4=1:M3
                if max(abs(p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1)))>1e-10
                p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1)=expv(dt/2,getEX(NEAmax,NEA,(i1-1)*h1),p(baseEA+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+i4-1));
                end;    
            end;
        end;
    end;
    % EB, dt/2
    for i1=1:M1
        for i2=1:M1
            for i3=1:M2
                if max(abs(p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3)))>1e-10
                p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3)=expv(dt/2,getEY(NEAmax,NEB,(i2-1)*h1),p(baseEB+(i1-1)*M1*M2*M3+(i2-1)*M2*M3+(i3-1)*M3));
                end;
            end;
        end;
    end;
end;
toc;
disp({'NEB=',NEB, 'is over'});