%% Test the stiffness of the problem
% A<->B, B<->C

%% Some prepare work
N=30;M=N+1;p=zeros(M^3,1);p((M-1)*M^2+1)=1;
Pab=GetMatrix(N,10,10);Pbc=GetMatrix(N,0.01,0.01);
tend=3;dtoc=1/4;dtrk2=1/4;
baseAB=1:M:M^3;
baseBC=1:1:M^2;
%% using Krylov to get real solution.
Pwhole=whole3D(N,10,10,0.01,0.01);
pexa=expv(tend,Pwhole,p);

%% ocIIF method
poc=p;
Eab=expm(Pab*dtoc/2);Ebc=expm(Pbc*dtoc);
for step=1:(round(tend/dtoc))
    for j=1:M
        poc(baseAB+j-1)=Eab*poc(baseAB+j-1);
    end;
    for i=1:M
        poc(baseBC+(i-1)*M^2)=Ebc*poc(baseBC+(i-1)*M^2);
    end;
    for j=1:M
        poc(baseAB+j-1)=Eab*poc(baseAB+j-1);
    end;
end;
% Get result
disp('result for ocIIF')
disp({'the time step is:',dtoc});
disp({'the minimum is:',min(poc)});
disp({'the total probability',sum(poc)});
disp({'the error is:',max(abs(poc-pexa))})



%% RK2 method
prk2=p;
for step=1:round(tend/dtrk2)
    prk2=prk2+dtrk2*Pwhole*(prk2+0.5*dtrk2*Pwhole*prk2);
end;
% Get result
disp('result for RK2')
disp({'the time step is:',dtrk2});
disp({'the minimum is:',min(prk2)});
disp({'the total probability',sum(prk2)});
disp({'the error is:',max(abs(prk2-pexa))});
    
    
    
    
    

